/* confirmation utility functions */

#include "confirm.h"

confirmWidgetStruct *MakeConfirmedPopup(parentW, name, Func, x, y)
     Widget   *parentW;
     char     *name;
     void *Func;
     Dimension x, y;
{
  Widget popW, boxW, labelW, yesW, noW;
  Arg args[2];
  int nargs;
  static char fullname[64], geometry[64];
  confirmWidgetStruct *cw;

  cw = (confirmWidgetStruct *) malloc(sizeof(confirmWidgetStruct));

  nargs = 0;
  sprintf(fullname,"popConfirm%s", name);
  XtSetArg(args[nargs], XtNtitle, fullname); nargs++;
  sprintf(geometry, "+%d+%d", x, y);
  XtSetArg(args[nargs], XtNgeometry, geometry); nargs++;
  popW = XtCreatePopupShell(fullname, 
                            transientShellWidgetClass,
                            *parentW, args, nargs);
  nargs = 0;
  XtSetArg(args[nargs], XtNorientation, XtorientHorizontal); nargs++;
  boxW = XCMW("box", boxWidgetClass, popW, args, nargs);
  nargs = 0;
  XtSetArg(args[nargs], XtNborderWidth, 0); nargs++;
  labelW = XCMW("confirm", labelWidgetClass, boxW, args, nargs);

  yesW = XCMW("yes", commandWidgetClass, boxW, NULL, 0);
  noW  = XCMW( "no", commandWidgetClass, boxW, NULL, 0);

  XtAddCallback(yesW, XtNcallback, Func, cw);
  XtAddCallback( noW, XtNcallback, Func, cw);

  cw->pop = popW;
  cw->yes = yesW;
  cw->no  = noW;
  return (cw);
}
