#include "xpartinfo.h"

void GetSpecialNodeMap(specialNodeMapFileName)
     char *specialNodeMapFileName;
{
  int i, value;
  char description[256];
  FILE *file;

  if((file = fopen(specialNodeMapFileName, "r")) == NULL) {
    fprintf(stderr, "%s: could not open %s\n", 
            progName, specialNodeMapFileName);
    exit(1);
  }

  fscanf(file, "%d %s", &noSpecialNodes, description);

  specialNodes      = (int *) malloc(noSpecialNodes*sizeof(int));
  specialNodesDescr = (char **) malloc(noSpecialNodes*sizeof(char *));

  for (i=0; i < noSpecialNodes; i++) {
    fscanf(file, "%d %s", &value, description);
    specialNodes[i] = value;
    specialNodesDescr[i] = 
      strcpy((char *) malloc(strlen(description)+1), description);
  }

  fclose(file);
}

int GetActualLoadValue(loadValueFileName)
     char *loadValueFileName;
{
  int i;
  FILE *file;

  actualLoadValue = 0.0;

  if((file = fopen(loadValueFileName, "r")) == NULL) {
    return(-10);
  }

  i = fscanf(file, "%lf", &actualLoadValue) - 1;
  fclose(file);

  return(i);

}


char *DateOfFile();
char *TheTimeAndDate();
void FillNodeUseTable();

int GetPartInfo(partInfoFileName, partInfoDate, nJobs, jobsWaiting)
     char *partInfoFileName, **partInfoDate;
     int *nJobs, *jobsWaiting;
{
  int i, j, firstdef, index, NodesToPlace;
  char user[64], type[64], NodeBuffer[1024];
  FILE *file;
  extern int Maxparts;
  extern struct allocatedPartition *Parts;
  if((file = fopen(partInfoFileName, "r")) == NULL) 
    if((file = fopen(partInfoFileName, "r")) == NULL)
      if((file = fopen(partInfoFileName, "r")) == NULL) {
	*partInfoDate = TheTimeAndDate();
	return(-10);
      }

  *partInfoDate = DateOfFile(partInfoFileName);

  index = *nJobs = *jobsWaiting = totalNoNodesUsed = 0;
  /* initialize use of nodes -- first to "unused", then handle special */
  for (i=0; i<NONODES; i++)
    NodeUseTable[i] = -1;
  for (i=0; i<noSpecialNodes; i++)
    NodeUseTable[specialNodes[i]] = -2;

/* decode pstat -v output for paragon */
  i = fscanf(file, "%s %*s %*s %*s %*s %*s %*s %*s %s", user, type);
  if (i != 2) {fclose(file); return (-1);}
  if ( strcmp(user,"PARTITION") ) {fclose(file); return (-2);}
  if ( strcmp(type,"PART_SZ") ) {fclose(file); return (-2);}
  while ((! feof(file)) && index < NMAX ) {
    if ( index >= Maxparts-2 ) {
      Maxparts += STARTNJOBS;
      Parts = (struct allocatedPartition *) realloc(Parts, 
		(Maxparts)*sizeof(struct allocatedPartition));
      for (j=Maxparts-STARTNJOBS; j<Maxparts; j++)
	Parts[index].Nodes = NULL;
    }
    if (Parts[index].Nodes) {
      free(Parts[index].Nodes);
      Parts[index].Nodes = NULL;
    }
    i = fscanf(file, "%s %s %ld %*s %ld %d %d %[^a-wA-Z\n]", 
	       Parts[index].PartIds,
	       Parts[index].Users,
	       &(Parts[index].PGID),
	       &(Parts[index].CPU),
	       &(Parts[index].AppSz),
	       &(Parts[index].PartSz),
	       NodeBuffer);

    if (i == -1) break;
    if (i != 7) {fclose(file); return (-3);}
    if (Parts[index].PartSz > 0) 
      if (Parts[index].CPU == 0) {
	NodeBuffer[0] = NULL;
	(*jobsWaiting)++;
      }
      else if (Parts[index].PartSz > Parts[index].AppSz){ 
	/* case where the application smaller than the partition */
	firstdef = -1; 	
	for (j=0; j<index; j++) 
	  if (strcmp(Parts[index].PartIds, Parts[j].PartIds) == 0) {
	    firstdef = j;
	    break;
	  }
	if (firstdef < 0) {     /* first occurance of this partition */
	  if (Parts[index+1].Nodes) {
	    free(Parts[index+1].Nodes);
	    Parts[index].Nodes = NULL;
	  }
	  Parts[index+1] = Parts[index];
	  Parts[index].Nodes = 
	    strcpy((char *) malloc(strlen(NodeBuffer)+1), NodeBuffer);

	  FillNodeUseTable(NodeBuffer, index);
	  strcpy(Parts[index].Users, "0");
	  Parts[index].PGID = Parts[index].CPU = Parts[index].AppSz
	    = Parts[index].PartSz = 0;
	  firstdef = index;
	  index++;
	}
	NodesToPlace = Parts[index].AppSz;
	NodeBuffer[0] = NULL;
	for (j=0; (j<NONODES) && (NodesToPlace>0); j++) 
	  if (NodeUseTable[j] == firstdef) {
	    NodesToPlace--;	  
	    sprintf(type, " %d", j);	 
	    strcat(NodeBuffer, type);
	  }
	totalNoNodesUsed += Parts[index].AppSz;
	(*nJobs)++;
      } else { 
	totalNoNodesUsed += Parts[index].AppSz;
	(*nJobs)++;
      }
    Parts[index].Nodes = 
      strcpy((char *) malloc(strlen(NodeBuffer)+1), NodeBuffer);
    FillNodeUseTable(NodeBuffer, index);
    index++;
  }
  fclose(file);
  return(index);
}

void FillNodeUseTable(ptr, job)
  char *ptr;
  int job;
{
  int i, j, k, n1, n2, corner;
  
  while (*ptr != '\0') {
    if ((i = sscanf(ptr, " %dx%d:%d",&n1,&n2, &corner)) == 3) {
      for(j=0; j<n1; j++)
	for(k=0; k<n2; k++) 
	  NodeUseTable[j*NCOLS+(corner+k)] = job;
      while (*ptr != '\0' && *ptr != ' ') ptr++;
      if (*ptr == ' ') ptr++;
    }
    else if ((i = sscanf(ptr, "%d..%d",&n1,&n2)) == 2) {
      for(j=n1; j<=n2; j++)
	NodeUseTable[j] = job;
      while (*ptr != '\0' && *ptr != ' ') ptr++;
      if (*ptr == ' ') ptr++;
    }
    else if ((i = sscanf(ptr, "%d",&n1)) == 1) {
      NodeUseTable[n1] = job;
      while (*ptr != '\0' && *ptr != ' ') ptr++;
      if (*ptr == ' ') ptr++;
    }
  }
}

void MakeNodeMap()
{
    int x, y;
    int p;

    /* Fill in the nodeNums matrix with physical processor numbers. */

    for(x=0; x<NCOLS; x++)
      for(y=0; y<NROWS; y++)
	nodeNums[x][y] = x + y*NCOLS;

    /* Fill in the nodeColumn, nodeRow for each proc */
    for(x=0; x<NCOLS; x++){
      for(y=0; y<NROWS; y++){
        p = nodeNums[x][y];
        nodeColumn[p] = x;
        nodeRow[p]    = y;
      }
    }
  }

