#include "xpartinfo.h"
#include "colors.h"

#define QUOTE '\042'

void DrawNode(), Update(), ShowMessage();
static int xl, yl;
static char partlist[256];

void Resetpartlist()
{
  partlist[0] = '\0';
}

void Handle(widget, p_nPPN, event)
     Widget widget;
     int *p_nPPN;
     XEvent *event;
{
  int i, x, y, xx, yy, node, ncol, nrow, color, nPPN = *p_nPPN;
  char thePartition[64], message[256];
  extern struct allocatedPartition *Parts;
  
  switch((int) (*event).type) {
    
  case ButtonPress:
    x = (*event).xbutton.x/nPPN;
    y = (*event).xbutton.y/nPPN;
    switch ((*event).xbutton.button){
    case Button1:
      color = MIN(MXC_COLOR,noColors);
      xl = x; yl = y;
      DrawNode(nodeNums[xl][yl], color, nPPN);
      RefreshPartition();
      break;

    case Button2:
      Update(NULL, NULL, NULL);
      break;

    case Button3:
      i = NodeUseTable[nodeNums[x][y]];
      if (i >= 0) 
	if (Parts[i].PGID == 0)
	  sprintf(message,"Node %d is in partition %s ",
		  nodeNums[x][y], Parts[i].PartIds);
	else
	  sprintf(message,"%s %s %d/%d nodes, %ld cpu nodesecs, %ld PGID",
		  Parts[i].Users,
		  Parts[i].PartIds,
		  Parts[i].AppSz,
		  Parts[i].PartSz,
		  Parts[i].CPU,
		  Parts[i].PGID);
      else if (i == -2)
	for (i=0; i<noSpecialNodes; i++) {
	  node = specialNodes[i];
	  xl = x - nodeColumn[node];
	  yl = y - nodeRow[node];
	  if (xl == 0 && yl == 0) 
	    sprintf(message,"node %d: %s\n",
		    specialNodes[i],
		    specialNodesDescr[i]);
	}
      else if (i == -1)
	sprintf(message, "node %d not in any partition.", nodeNums[x][y]);
      ShowMessage(message);
      break;
    }
    
    break;

  case ButtonRelease:
    xx = (*event).xbutton.x/nPPN;
    yy = (*event).xbutton.y/nPPN;
    switch ((*event).xbutton.button){
    case Button1:
      node = nodeNums[MIN(xl,xx)][MIN(yl,yy)];
      ncol = xx - xl; if (ncol<0) ncol = -ncol; ncol++;
      nrow = yy - yl; if (nrow<0) nrow = -nrow; nrow++;
      color = MIN(MXC_COLOR,noColors);
      if ( (ncol == 1) && (nrow == 1) ) {
	sprintf(thePartition, "%d", node);
	DrawNode(node, color, nPPN);
      }
      else {
	sprintf(thePartition, "%dx%d:%d", nrow, ncol, node); 
	setColor(color);
	drawPart(nPPN, node, nrow, ncol);
      }
      RefreshPartition();
      if (partlist[0] != '\0')
	strcat(partlist, ",");
      strcat(partlist, thePartition);
      sprintf(message,"Partition is %s", partlist);
      ShowMessage(message);
      break;

    case Button2:
    case Button3:
      break;
    }
  }
}

findNode(x,y,types)
    int x;
    int y;
    char *types;
{
    char *ptr;
    int result, point_node;
    int i,n1,n2,corner;

    result = 0;
    point_node = nodeNums[x][y];
    ptr = types;
    while (!result && *ptr != '\0' && *ptr != ' ') {
        if ((i = sscanf(ptr, "(%d,%d)%d", &n1, &n2, &corner)) == 3) {
            xl = x - nodeColumn[corner];
            yl = y - nodeRow[corner];
            if (xl >= 0 && xl < n2 && yl >= 0 && yl < n1) {
                 result = 1;
                 break;
            }
            while (*ptr != '\0' && *ptr != ')') ptr++;
            if (*ptr == ')') {
                while (*ptr != '\0' && *ptr != ',') ptr++;
                if (*ptr == ',') ptr++;
            }
        }
        else if ((i = sscanf(ptr, "%d..%d",&n1,&n2)) == 2) {
            if (point_node >= n1 && point_node <= n2) {
                result = 1;
                break;
            }
            while (*ptr != '\0' && *ptr != ' ') ptr++;
            if (*ptr == ' ') ptr++;
        }
        else if ((i = sscanf(ptr, "%d",&n1)) == 1) {
            if (point_node == n1) {
                result = 1;
                break;
            }
            while (*ptr != '\0' && *ptr != ' ') ptr++;
            if (*ptr == ' ') ptr++;
        }
        else {
            fprintf(stderr, "Illegal type format\n");
            break;
        }
    }
    return(result);
}
