#include <stdio.h>
#include <string.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

/* title of X window */
#define className "XPartInfo for paragon.sdsc.edu"

#define MIN(x,y) (((x)<(y))?(x):(y))
#define MAX(x,y) (((x)>(y))?(x):(y))

/* cabinet size */
#ifndef NROWS
#define NROWS (16)
#endif

#ifndef NCOLS
#define NCOLS (28)
#endif

#ifndef MINWIDTH
#define MINWIDTH (32)
#endif

#define NONODES (NROWS*NCOLS)

/* StripCharts height (in pixels) */
#define LOAD_SC_HEIGHT    16
#define NONODES_SC_HEIGHT 16

/* StripCharts scales             */
#define LOAD_SC_SCALE      3
#define NONODES_SC_SCALE   4

/* StripCharts update interval in secs */
int     updateSC;

/* maps of the physical node nums */
int nodeNums[NCOLS][NROWS];
int nodeColumn[NONODES];
int nodeRow[NONODES];

/* list of special nodes and their description */
int   *specialNodes;
char **specialNodesDescr;
int noSpecialNodes;

/* Table listing use of each node: 
 *  -1 -> unused
 *  -2 -> special
 *   x>=0 -> allocated to job x
 */

short int NodeUseTable[NONODES];

/* list of allocated partitions */

#define STARTNJOBS (8)    /* guess at number of jobs in system */
#define NTYPE (128)
#define NUSER (32)
#define NMAX  (32)
#define NFIELD (16)

struct allocatedPartition {
  char PartIds[NTYPE];
  char Users[NUSER];
  long PGID;
  long CPU;
  int AppSz;
  int PartSz;
  char *Nodes;
};

int totalNoNodesUsed;
double actualLoadValue;

/* colors */
#define NOCOLORSMAX 7
Pixel  colors[NOCOLORSMAX];
Pixmap stipples[NOCOLORSMAX];
int    noColors;

/* global variable that contains the program name */
char  *progName;


