/*
 * `private' header for xpartinfo Ver 3.x
 */

#ifndef PARTINFOFILENAME
#define PARTINFOFILENAME "partinfo.dat"
#endif

#ifndef LOADVALUEFILENAME
#define LOADVALUEFILENAME "rshtime.dat"
#endif

#ifndef SPECIALNODEMAPFILENAME
#define SPECIALNODEMAPFILENAME "special.node.map.dat"
#endif

#ifndef STATUSFILENAME
#define STATUSFILENAME "status"
#endif

/*
 * typedef struct def for RDB structure 
 */

typedef struct {
  int     nPPN;
  int     updateDelay;
  char   *specialNodeMapFileName,
         *partInfoFileName,
         *loadValueFileName,
         *statusFileName,
         *user;
  Boolean showUsage;
  Boolean monochrome;
  Boolean showNoNodesSC, showLoadSC;
} theResourcesStruct, *theResourcesPtr;

typedef struct {
  Pixel   fg, bg, spn, ptn, upt, mxc, ept;
} theColorResourcesStruct, *theColorResourcesPtr;

typedef struct {
  Pixel   fg, bg;
/*, spn, ptn, upt, mxc; */
} theMonoResourcesStruct, *theMonoResourcesPtr;

/*
 * actual Xt resources:
 */
static XtResource resources[] = {
  { "updateDelay", "UpdateDelay", XtRInt, sizeof(int),
    XtOffset(theResourcesPtr,updateDelay), XtRString, "60" },

  { "sizeFactor", "SizeFactor", XtRInt, sizeof(int),
    XtOffset(theResourcesPtr,nPPN), XtRString, "10" },

  { "partInfoFileName", "PartInfoFileName", XtRString, sizeof(String),
    XtOffset(theResourcesPtr,partInfoFileName), XtRString, PARTINFOFILENAME },

  { "loadValueFileName", "LoadValueFileName", XtRString, sizeof(String),
    XtOffset(theResourcesPtr,loadValueFileName), XtRString, 
    LOADVALUEFILENAME },

  { "specialNodeMapFileName", "SpecialNodeMapFileName",
    XtRString, sizeof(String),
    XtOffset(theResourcesPtr,specialNodeMapFileName), XtRString, 
    SPECIALNODEMAPFILENAME },

  { "statusFileName", "StatusFileName", XtRString, sizeof(String),
    XtOffset(theResourcesPtr,statusFileName), XtRString, STATUSFILENAME },

  { "userHighlighted", "UserHighlighted", XtRString, sizeof(String),
    XtOffset(theResourcesPtr,user), XtRString, "nobody"},

  { "monochrome", "Monochrome", XtRBoolean, sizeof(Boolean),
    XtOffset(theResourcesPtr,monochrome), XtRString, "False" },

  { "showNoNodesSC", "ShowNoNodesSC", XtRBoolean, sizeof(Boolean),
    XtOffset(theResourcesPtr,showNoNodesSC), XtRString, "True" },

  { "showLoadSC", "ShowLoadSC", XtRBoolean, sizeof(Boolean),
    XtOffset(theResourcesPtr,showLoadSC), XtRString, "True" },

  { "help", "Help", XtRBoolean, sizeof(Boolean),
    XtOffset(theResourcesPtr,showUsage), XtRString, "False" }
};

static XtResource monoResources[] = {
  { XtNforeground, XtCForeground, XtRPixel, sizeof(Pixel), 
    XtOffset(theMonoResourcesPtr,fg), XtRString, XtDefaultForeground },

  { XtNbackground, XtCBackground, XtRPixel, sizeof(Pixel), 
    XtOffset(theMonoResourcesPtr,bg), XtRString, XtDefaultBackground }
};

static XtResource colorResources[] = {
  { XtNforeground, XtCForeground, XtRPixel, sizeof(Pixel), 
    XtOffset(theColorResourcesPtr,fg), XtRString, XtDefaultForeground },

  { XtNbackground, XtCBackground, XtRPixel, sizeof(Pixel), 
    XtOffset(theColorResourcesPtr,bg), XtRString, XtDefaultBackground },

  { "specialNodesColor", "SpecialNodesColor", XtRPixel, sizeof(Pixel), 
    XtOffset(theColorResourcesPtr,spn), XtRString, "blue" },

  { "allocatedPartitionColor", "AllocatedPartitionColor",
    XtRPixel, sizeof(Pixel), 
    XtOffset(theColorResourcesPtr,ptn), XtRString, "red" },

  { "highlightedPartitionColor", "HighlightedPartitionColor",
    XtRPixel, sizeof(Pixel), 
    XtOffset(theColorResourcesPtr,upt), XtRString, "brown" },

  { "selectedPartitionColor", "SelectedPartitionColor",
    XtRPixel, sizeof(Pixel), 
    XtOffset(theColorResourcesPtr,mxc), XtRString, "purple" },

  { "existingPartitionColor", "ExistingPartitionColor",
    XtRPixel, sizeof(Pixel), 
    XtOffset(theColorResourcesPtr,ept), XtRString, "pink" }
};


/* options */
static XrmOptionDescRec options[] = {
  {"-ud",        "*updateDelay",               XrmoptionSepArg, NULL},
  {"-sf",        "*sizeFactor",                XrmoptionSepArg, NULL},
  {"-user",      "*userHighlighted",           XrmoptionSepArg, NULL},
  {"-sncolor",   "*specialNodesColor",         XrmoptionSepArg, NULL},
  {"-apcolor",   "*allocatedPartitionColor",   XrmoptionSepArg, NULL},
  {"-hpcolor",   "*highlightedPartitionColor", XrmoptionSepArg, NULL},
  {"-spcolor",   "*selectedPartitionColor",    XrmoptionSepArg, NULL},
  {"-epcolor",   "*existingPartitionColor",    XrmoptionSepArg, NULL},
  {"-pifn",      "*partInfoFileName",          XrmoptionSepArg, NULL},
  {"-snfn",      "*specialNodeMapFileName",    XrmoptionSepArg, NULL},
  {"-stfn",      "*statusFileName",            XrmoptionSepArg, NULL},
  {"-mono",      "*monochrome",                XrmoptionNoArg, "True"},
  {"-nodesc",    "*showNoNodesSC",             XrmoptionNoArg, "False"},
  {"-loadsc",    "*showLoadSC",                XrmoptionNoArg, "False"},
  {"+nodesc",    "*showNoNodesSC",             XrmoptionNoArg, "True"},
  {"+loadsc",    "*showLoadSC",                XrmoptionNoArg, "True"},
  {"-ldfn",      "*loadValueFileName",         XrmoptionSepArg, NULL},
  {"-help",      "*help",                      XrmoptionNoArg, "True"}
};

/* usage */
static char *usageOptions[] = {
" where options can be any X-toolkit option, as well as:",
"",
"  Option             Description                     Resource: default value",
"  ------             -----------                     -----------------------",
"  -ud #              delay between updates [sec]          (*updateDelay: 60)",
"  -sf #              partition map size factor             (*sizeFactor: 10)",
"  -user <username>   user to be highlighted       (*userHighlighted: nobody)",
"  -mono              force monochrome mode on color display",
"                                                        (*monochrome: False)",
"  -sncolor <color>   color for special nodes      (*specialNodesColor: blue)",
"  -apcolor <color>   color for allocated partions",
"                                            (*allocatedPartitionColor:  red)",
"  -hpcolor <color>   color for highlighted partitions",
"                                          (*highlightedPartitionColor: brown)",
"  -spcolor <color>   color for selected partitions",
"                                            (*selectedPartitionColor: green)",
"  -epcolor <color>   color for existing partitions",
"                                            (*existingPartitionColor: pink)",
"  -pifn <filename>   file with output of `partinfo -s'",
"                                           (*partInfoFileName:",
                                              PARTINFOFILENAME,
"  -snfn <filename>   file with list of special node map",
"                                           (*specialNodeMapFileName:",
                                              SPECIALNODEMAPFILENAME,
"  -stfn <filename>   file with status information",
"                                           (*statusFileName:",
                                              STATUSFILENAME,
"  +nodesc            graph # nodes used strip chart  (*showNoNodesSC: True)",
"  -nodesc            disable # nodes used strip chart",
"  +loadsc            graph `rsh paragon' load             (*showLoadSC: True)",
"  -loadsc            disable graph `rsh paragon' load",
"  -ldfn <filename>   file with load info",
"                                           (*loadValueFileName:",
                                              LOADVALUEFILENAME,
"  -help              produce this help list                   (*help: False)",
"",
" left button:",
"   display the mexec command for the selected fictious partition",
" middle button:",
"   update the partition display",
" right button:",
"   identify the selected partition or special node",
    NULL};

static unsigned char hatch[]={
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
  0x88, 0x44, 0x22, 0x11, 0x88, 0x44, 0x22, 0x11,
  0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
  0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00,
  0x77, 0xdd, 0xdd, 0x77, 0x77, 0xdd, 0xdd, 0x77,
  0x01, 0x08, 0x40, 0x02, 0x10, 0x80, 0x04, 0x20,
  0x11, 0x44, 0x11, 0x44, 0x11, 0x44, 0x11, 0x44
  };

